<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>HexPlot: /home/ericabro/HexPlot/20200528/HGCAL_sensor_analysis/src/exec/flat_plot.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.1 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
<h1>/home/ericabro/HexPlot/20200528/HGCAL_sensor_analysis/src/exec/flat_plot.h</h1><a href="flat__plot_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00007"></a>00007 <span class="preprocessor">#ifndef FLAT_PLOT_H</span>
<a name="l00008"></a>00008 <span class="preprocessor"></span><span class="preprocessor">#define FLAT_PLOT_H</span>
<a name="l00009"></a>00009 <span class="preprocessor"></span>
<a name="l00010"></a>00010 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00011"></a>00011 <span class="preprocessor">#include &lt;utility&gt;</span>
<a name="l00012"></a>00012 
<a name="l00013"></a>00013 <span class="preprocessor">#include &quot;TCanvas.h&quot;</span>
<a name="l00014"></a>00014 <span class="preprocessor">#include &quot;TGaxis.h&quot;</span>
<a name="l00015"></a>00015 <span class="preprocessor">#include &quot;TGraphErrors.h&quot;</span>
<a name="l00016"></a>00016 <span class="preprocessor">#include &quot;TH1F.h&quot;</span>
<a name="l00017"></a>00017 <span class="preprocessor">#include &quot;TLegend.h&quot;</span>
<a name="l00018"></a>00018 <span class="preprocessor">#include &quot;TPad.h&quot;</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;../utils/cpp_utils.h&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;../utils/root_utils.h&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="globals_8h.html" title="A collection of global variables.">globals.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00025"></a><a class="code" href="classflat__plot.html">00025</a> <span class="keyword">class </span><a class="code" href="classflat__plot.html" title="A class for plotting different kinds of 1D plots.">flat_plot</a> {
<a name="l00026"></a>00026  <span class="keyword">public</span>:
<a name="l00027"></a>00027   <span class="keywordtype">void</span> fill_data(TH1F *h);
<a name="l00028"></a>00028   <span class="keywordtype">void</span> fill_data(std::vector&lt;TH1F *&gt; &amp;h_vec);
<a name="l00029"></a>00029   <span class="keywordtype">void</span> fill_data(TH2F *h);
<a name="l00030"></a>00030 
<a name="l00032"></a>00032   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#a3850576115cffffdcf1559cefbd638ac" title="Produces the value vs pad number plot.">draw_flat</a>(<span class="keyword">const</span> std::string &amp;outputFile);
<a name="l00034"></a>00034   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#ae44ac728216963c9b00f5c67fd7937bc" title="Writes the average values of each pad category to file.">write_average_values</a>(<span class="keyword">const</span> std::string &amp;outputFile, <span class="keywordtype">bool</span> yesToAll = <span class="keyword">false</span>);
<a name="l00036"></a>00036   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#a063ab6604e303aaeeddd544a8e72dbb0" title="Produces the distributions of values within each category.">draw_flat_category_distr</a>(<span class="keyword">const</span> std::string &amp;outputFile);
<a name="l00038"></a>00038   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#a699c36e9e091de5fb1eb73d542009ab1" title="Produces the distributions of values for the pads marked as special.">draw_flat_category_distr_spec</a>(<span class="keyword">const</span> std::string &amp;outputFile);
<a name="l00040"></a>00040   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#a7c128232f0b600087be31ebac00e62d4" title="Produces the average value vs category plot.">draw_flat_category</a>(<span class="keyword">const</span> std::string &amp;outputFile);
<a name="l00042"></a>00042   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#ad728b6ee4811b8da63950ab1712db8ca" title="Produces the average value vs category plot, scaled with pad surface.">draw_flat_category_rel</a>(<span class="keyword">const</span> std::string &amp;outputFile, std::vector&lt;double&gt; padSurfaceVec);
<a name="l00044"></a>00044   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#a8dd71497d4bb2f6b057740c6705c19c8" title="Produces the average value per category vs sensor name plot.">draw_flat_category_sensors</a>(<span class="keyword">const</span> std::string &amp;outputFile);
<a name="l00046"></a>00046   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#a67ed070fc9bf437e6522e63f6cb313fc" title="Produces the value vs selector plot, e.g. single pad IV or CV curves.">draw_pad</a>(<span class="keyword">const</span> std::string &amp;outputFile, <span class="keywordtype">bool</span> isCVInput = <span class="keyword">false</span>);
<a name="l00048"></a>00048   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#a86af15b67b5adc091609a2f586b29147" title="Produces the value vs selector plot for different special cells.">draw_pads</a>(<span class="keyword">const</span> std::string &amp;outputFile);
<a name="l00050"></a>00050   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#a9bcdcb74f0ca502c3db7c51eaa9852a3" title="Produces the mean and the median values vs selector for different special cells.">draw_pads_stat</a>(<span class="keyword">const</span> std::string &amp;outputFile, <span class="keywordtype">bool</span> summary = <span class="keyword">false</span>, <span class="keywordtype">bool</span> yesToAll = <span class="keyword">false</span>,
<a name="l00051"></a>00051                       <span class="keyword">const</span> std::string &amp;summaryFile = <span class="stringliteral">&quot;summary.txt&quot;</span>, <span class="keywordtype">bool</span> saving = <span class="keyword">false</span>);
<a name="l00053"></a>00053   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#aef9af3c7436071c8a4e50cc690453f64" title="Produces the mean and the median values vs selector for different special cells.">draw_pads_stats</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt; &amp;inputFileList, <span class="keyword">const</span> std::string &amp;outputFile);
<a name="l00055"></a>00055   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#a918bd60e67bba3c65e87e9154c7fd596" title="Writes out some info on full sensor.">write_full</a>(<span class="keyword">const</span> std::string &amp;outputFile, <span class="keywordtype">bool</span> showMaxValue = <span class="keyword">true</span>, <span class="keywordtype">bool</span> yesToAll = <span class="keyword">false</span>);
<a name="l00057"></a>00057   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#aff80ffb8287da98da8cefbe514f3d2af" title="Produces a 2D plot of pad number vs voltages vs value fraction of respective pad...">draw_full_rel</a>(<span class="keyword">const</span> std::string &amp;outputFile, <span class="keywordtype">bool</span> showMaxValue = <span class="keyword">true</span>);
<a name="l00059"></a>00059   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#a5194536bf0071f98d1058ce7f5dab8ae" title="Produces a 2D plot of pad number vs voltages vs value in lego plot option.">draw_full_lego</a>(<span class="keyword">const</span> std::string &amp;outputFile);
<a name="l00061"></a>00061   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#accee432f042c2dc99c320a1b8e4b0413" title="Produces pad number vs value overlayed for all voltages.">draw_full_profiles</a>(<span class="keyword">const</span> std::string &amp;outputFile);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="keywordtype">void</span> set_aspect_ratio(<span class="keywordtype">double</span> x, <span class="keywordtype">double</span> y) {
<a name="l00064"></a>00064     aspectRatioX = int(x);
<a name="l00065"></a>00065     aspectRatioY = int(y);
<a name="l00066"></a>00066   };
<a name="l00067"></a>00067   <span class="keywordtype">void</span> set_is_average(<span class="keywordtype">bool</span> p, std::vector&lt;std::string&gt; v) {
<a name="l00068"></a>00068     isAverageValues = p;
<a name="l00069"></a>00069     inputFiles = std::move(v);
<a name="l00070"></a>00070   };
<a name="l00071"></a>00071   <span class="keywordtype">void</span> set_is_ratio(<span class="keywordtype">bool</span> p, std::vector&lt;std::string&gt; v) {
<a name="l00072"></a>00072     isRatioValues = p;
<a name="l00073"></a>00073     inputFiles = std::move(v);
<a name="l00074"></a>00074   };
<a name="l00076"></a><a class="code" href="classflat__plot.html#ad74194f1dac92f723640a70ab731019a">00076</a>   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#ad74194f1dac92f723640a70ab731019a" title="Set value is derived, e.g. a depletion voltage.">set_is_raw_data</a>(<span class="keywordtype">bool</span> p) { isRawData = p; };
<a name="l00077"></a>00077   <span class="keywordtype">void</span> set_pad_type_strings(std::vector&lt;std::string&gt; v) { padTypeStrings = std::move(v); };
<a name="l00078"></a>00078   <span class="keywordtype">void</span> set_pad_types(std::vector&lt;int&gt; v) { padTypes = std::move(v); };
<a name="l00079"></a>00079   <span class="keywordtype">void</span> set_range(<span class="keywordtype">double</span> min = 0, <span class="keywordtype">double</span> max = 0) {
<a name="l00080"></a>00080     zoomMin = min;
<a name="l00081"></a>00081     zoomMax = max;
<a name="l00082"></a>00082   };
<a name="l00083"></a>00083   <span class="keywordtype">void</span> set_selector(<span class="keywordtype">double</span> p) { selector = p; };
<a name="l00084"></a>00084   <span class="keywordtype">void</span> set_selector_labels(std::vector&lt;std::string&gt; v) { selectorLabels = std::move(v); };
<a name="l00085"></a>00085   <span class="keywordtype">void</span> set_special_cell_collection(std::vector&lt;std::string&gt; v) { specialCellCollection = std::move(v); };
<a name="l00086"></a>00086   <span class="keywordtype">void</span> set_special_cell_names(std::vector&lt;std::string&gt; v) { specialCellNames = std::move(v); };
<a name="l00087"></a>00087   <span class="keywordtype">void</span> set_special_cell_numbers(std::vector&lt;std::vector&lt;int&gt;&gt; v) { specialCellNumbers = std::move(v); };
<a name="l00089"></a><a class="code" href="classflat__plot.html#a8824a43b6b7d3356129492d070699b76">00089</a>   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#a8824a43b6b7d3356129492d070699b76" title="Print out hashed info on result.">set_test_info</a>(<span class="keywordtype">bool</span> p) { testInfo = p; };
<a name="l00090"></a>00090   <span class="keywordtype">void</span> set_use_logy(<span class="keywordtype">bool</span> p = <span class="keyword">true</span>) { useLogVal = p; };
<a name="l00091"></a>00091   <span class="keywordtype">void</span> set_only_special(<span class="keywordtype">bool</span> p = <span class="keyword">true</span>) { onlySpecial = p; };
<a name="l00092"></a>00092   <span class="keywordtype">void</span> set_value_labels(std::vector&lt;std::string&gt; v) { valueLabels = std::move(v); };
<a name="l00093"></a>00093   <span class="keywordtype">void</span> set_verbose(<span class="keywordtype">int</span> p) { verbose = p; };
<a name="l00095"></a><a class="code" href="classflat__plot.html#ac8de6b16958d8221fa5ea89b7cacf6ff">00095</a>   <span class="keywordtype">void</span> <a class="code" href="classflat__plot.html#ac8de6b16958d8221fa5ea89b7cacf6ff" title="Set info text appearing in the top right corner of the plot.">set_top_left_info</a>(std::string s) { topLeftLabel = std::move(s); };
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <a class="code" href="classflat__plot.html" title="A class for plotting different kinds of 1D plots.">flat_plot</a>();
<a name="l00098"></a>00098 
<a name="l00099"></a>00099  <span class="keyword">private</span>:
<a name="l00100"></a>00100   <span class="keyword">const</span> <span class="keywordtype">bool</span> SINGLE_CELLS_FOR_AVERAGE = <span class="keyword">true</span>;
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="keywordtype">bool</span> initializedFlat;
<a name="l00103"></a>00103   <span class="keywordtype">bool</span> isAverageValues;
<a name="l00104"></a>00104   <span class="keywordtype">bool</span> isRatioValues;
<a name="l00105"></a>00105   <span class="keywordtype">bool</span> isRawData;
<a name="l00106"></a>00106   <span class="keywordtype">bool</span> onlySpecial;
<a name="l00107"></a>00107   <span class="keywordtype">bool</span> SuccessfullyLoaded;
<a name="l00108"></a>00108   <span class="keywordtype">bool</span> testInfo;
<a name="l00109"></a>00109   <span class="keywordtype">bool</span> useLogVal;
<a name="l00110"></a>00110   <span class="keywordtype">double</span> selector;
<a name="l00111"></a>00111   <span class="keywordtype">double</span> totalMax;
<a name="l00112"></a>00112   <span class="keywordtype">double</span> totalMin;
<a name="l00113"></a>00113   <span class="keywordtype">double</span> zoomMax;
<a name="l00114"></a>00114   <span class="keywordtype">double</span> zoomMin;
<a name="l00115"></a>00115   <span class="keywordtype">int</span> aspectRatioX;
<a name="l00116"></a>00116   <span class="keywordtype">int</span> aspectRatioY;
<a name="l00117"></a>00117   <span class="keywordtype">int</span> numberNAN;
<a name="l00118"></a>00118   <span class="keywordtype">int</span> numberOF;
<a name="l00119"></a>00119   <span class="keywordtype">int</span> standardpos;
<a name="l00120"></a>00120   <span class="keywordtype">int</span> verbose;
<a name="l00121"></a>00121   std::ofstream fileout;
<a name="l00122"></a>00122   std::vector&lt;int&gt; invlegendorder;
<a name="l00123"></a>00123   std::vector&lt;int&gt; legendorder;
<a name="l00124"></a>00124   std::vector&lt;int&gt; padTypes;
<a name="l00125"></a>00125   std::vector&lt;int&gt; special_types;
<a name="l00126"></a>00126   std::vector&lt;int&gt; types;
<a name="l00127"></a>00127   std::vector&lt;std::string&gt; inputFiles;
<a name="l00128"></a>00128   std::vector&lt;std::string&gt; padTypeStrings;
<a name="l00129"></a>00129   std::vector&lt;std::string&gt; selectorLabels;
<a name="l00130"></a>00130   std::vector&lt;std::string&gt; specialCellCollection;
<a name="l00131"></a>00131   std::vector&lt;std::string&gt; specialCellNames;
<a name="l00132"></a>00132   std::vector&lt;std::string&gt; valueLabels;
<a name="l00133"></a>00133   std::vector&lt;std::vector&lt;int&gt;&gt; cellWithType;
<a name="l00134"></a>00134   std::vector&lt;std::vector&lt;int&gt;&gt; specialCellNumbers;
<a name="l00135"></a>00135   TGraphErrors *gr_categories_sensors[MAX_CELL_TYPE];
<a name="l00136"></a>00136   TH1F *h_cat_sensors[MAX_CELL_TYPE][MAX_SENSOR_NUMBER];
<a name="l00137"></a>00137   TH1F *h_categories[MAX_CELL_TYPE + 1];
<a name="l00138"></a>00138   TH1F *h_categories_meanError[MAX_CELL_TYPE + 1];
<a name="l00139"></a>00139   TH1F *h_fill;
<a name="l00140"></a>00140   std::vector&lt;TH1F *&gt; h_fill_vec;
<a name="l00141"></a>00141   std::vector&lt;TGraphErrors *&gt; gr_means;
<a name="l00142"></a>00142   std::vector&lt;TGraphErrors *&gt; gr_medians;
<a name="l00143"></a>00143   TH1F *h_markers[MAX_CELL_TYPE];
<a name="l00144"></a>00144   TH1F *h_markers_proj[MAX_CELL_TYPE];
<a name="l00145"></a>00145   TH1F *h_markers_proj_zoom[MAX_CELL_TYPE];
<a name="l00146"></a>00146   TH2F *h_fill_2D;
<a name="l00147"></a>00147   TLegend *full_leg;
<a name="l00148"></a>00148   TLegend *leg;
<a name="l00149"></a>00149   TLegend *special_leg;
<a name="l00150"></a>00150   TPaveText *padVoltageInfo;
<a name="l00151"></a>00151   std::string topLeftLabel;
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <span class="keywordtype">bool</span> has_negative_values();
<a name="l00154"></a>00154   <span class="keywordtype">void</span> create_summary_file(<span class="keyword">const</span> std::string &amp;outputFile, <span class="keywordtype">bool</span> yesToAll = <span class="keyword">false</span>);
<a name="l00155"></a>00155   <span class="keywordtype">void</span> draw_warnings();
<a name="l00156"></a>00156   <span class="keywordtype">void</span> init_flat();
<a name="l00157"></a>00157   std::map&lt;double, std::vector&lt;double&gt;&gt; profile_pads();
<a name="l00158"></a>00158   TGraphErrors *profile_mean(<span class="keyword">const</span> std::map&lt;<span class="keywordtype">double</span>, std::vector&lt;double&gt;&gt; &amp;map_profile,
<a name="l00159"></a>00159                              std::map&lt;float, float&gt; bin_widths);
<a name="l00160"></a>00160   TGraphErrors *profile_median(std::map&lt;<span class="keywordtype">double</span>, std::vector&lt;double&gt;&gt; map_profile, std::map&lt;float, float&gt; bin_widths);
<a name="l00161"></a>00161 };
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="preprocessor">#endif</span>
</pre></div></div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr size="1"/><address style="text-align: right;"><small>Generated on 29 May 2020 for HexPlot by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
